package server

import (
	cr "git.loafle.net/commons_go/rpc"
	crpj "git.loafle.net/commons_go/rpc/protocol/json"
	"git.loafle.net/commons_go/server"

	"git.loafle.net/overflow/overflow_discovery/rpc"
)

func New(addr string) server.Server {
	rpcRegistry := cr.NewRegistry()
	rpc.RegisterRPC(rpcRegistry)

	rpcSH := newRPCServletHandler(rpcRegistry)
	rpcSH.RegisterCodec(crpj.Name, crpj.NewServerCodec())

	socketHandler := newSocketHandler(rpcSH)

	sh := newServerHandler(addr, socketHandler)
	s := server.New(sh)

	return s
}
